
// CBedit.cpp : AvP[ṼNX`܂B
//

#include "stdafx.h"
#include "afxwinappex.h"
#include "afxdialogex.h"
#include "CBedit.h"
#include "MainFrm.h"

#include "ChildFrm.h"
#include "CBeditDoc.h"
#include "CBeditView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CCBeditApp

BEGIN_MESSAGE_MAP(CCBeditApp, CWinAppEx)
	ON_COMMAND(ID_APP_ABOUT, &CCBeditApp::OnAppAbout)
	// W̃t@C{hLg R}h
	ON_COMMAND(ID_FILE_NEW, &CWinAppEx::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, &CWinAppEx::OnFileOpen)
	// ẄZbgAbv R}h
	ON_COMMAND(ID_FILE_PRINT_SETUP, &CWinAppEx::OnFilePrintSetup)
END_MESSAGE_MAP()


// CCBeditApp RXgNV

CCBeditApp::CCBeditApp()
{
	m_bHiColorIcons = TRUE;

	// ċN}l[W[T|[g܂
	m_dwRestartManagerSupportFlags = AFX_RESTART_MANAGER_SUPPORT_ALL_ASPECTS;
#ifdef _MANAGED
	// AvP[Vʌꃉ^C T|[g (/clr) gpč쐬Ăꍇ:
	//     1) ̒ǉݒ́AċN}l[W[ T|[gɋ@\邽߂ɕKvłB
	//     2) 쐬ɂ́AvWFNg System.Windows.Forms ւ̎QƂǉKv܂B
	System::Windows::Forms::Application::SetUnhandledExceptionMode(System::Windows::Forms::UnhandledExceptionMode::ThrowException);
#endif

	// TODO: ̃AvP[V ID ӂ ID Œu܂B
	// ̌` CompanyName.ProductName.SubProduct.VersionInformation ł
	SetAppID(_T("CBedit.AppID.NoVersion"));

	// TODO: ̈ʒuɍ\zpR[hǉĂB
	//  InitInstance ̏dvȏׂċLqĂB
}

// B CCBeditApp IuWFNgłB

CCBeditApp theApp;


// CCBeditApp 

BOOL CCBeditApp::InitInstance()
{
	// AvP[V }jtFXg visual X^CLɂ邽߂ɁA
	// ComCtl32.dll Version 6 ȍ~̎gpw肷ꍇ́A
	// Windows XP  InitCommonControlsEx() KvłBȂ΁AEBhE쐬ׂ͂Ďs܂B
	INITCOMMONCONTROLSEX InitCtrls;
	InitCtrls.dwSize = sizeof(InitCtrls);
	// AvP[VŎgp邷ׂẴR Rg[ NX܂߂ɂ́A
	// ݒ肵܂B
	InitCtrls.dwICC = ICC_WIN95_CLASSES;
	InitCommonControlsEx(&InitCtrls);

	CWinAppEx::InitInstance();


	// OLE Cu܂B
	if (!AfxOleInit())
	{
		AfxMessageBox(IDP_OLE_INIT_FAILED);
		return FALSE;
	}

	AfxEnableControlContainer();

	EnableTaskbarInteraction();

	// RichEdit Rg[gpɂ AfxInitRichEdit2() Kvł	
	// AfxInitRichEdit2();

	// W
	// ̋@\g킸ɍŏIIȎs\t@C
	// TCYkꍇ́Aȉsvȏ
	// [`폜ĂB
	// ݒ肪i[Ă郌WXg L[ύX܂B
	// TODO: Ж܂͑gDȂǂ̓K؂ȕ
	// ̕ύXĂB
	SetRegistryKey(_T("AvP[V EBU[hŐꂽ[J AvP[V"));
	LoadStdProfileSettings(4);  // W INI t@C̃IvV[h܂ (MRU ܂)


	InitContextMenuManager();

	InitKeyboardManager();

	InitTooltipManager();
	CMFCToolTipInfo ttParams;
	ttParams.m_bVislManagerTheme = TRUE;
	theApp.GetTooltipManager()->SetTooltipParams(AFX_TOOLTIP_TYPE_ALL,
		RUNTIME_CLASS(CMFCToolTipCtrl), &ttParams);

	// AvP[Vp̃hLg ev[go^܂BhLg ev[g
	//  ̓hLgAt[ EBhEƃr[邽߂ɋ@\܂B
	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(IDR_ProgramTYPE,
		RUNTIME_CLASS(CCBeditDoc),
		RUNTIME_CLASS(CChildFrame), // JX^ MDI qt[
		RUNTIME_CLASS(CCBeditView));
	if (!pDocTemplate)
		return FALSE;
	AddDocTemplate(pDocTemplate);

	// C MDI t[ EBhE쐬܂B
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame || !pMainFrame->LoadFrame(IDR_MAINFRAME))
	{
		delete pMainFrame;
		return FALSE;
	}
	m_pMainWnd = pMainFrame;

	// ڔ݂ꍇɂ̂ DragAcceptFiles Ăяo܂
	//  MDI AvP[Vł́ǍĂяóAm_pMainWnd ݒ肵ɔȂ΂Ȃ܂B
	// hbO/hbv I[v܂B
	m_pMainWnd->DragAcceptFiles();

	// DDEAfile open ȂǕW̃VF R}h̃R}h C͂܂B
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// DDE Execute open gp\ɂ܂B
	EnableShellOpen();
	RegisterShellFileTypes(TRUE);


	// R}h CŎw肳ꂽfBXpb` R}hłBAvP[V
	// /RegServerA/RegisterA/Unregserver ܂ /Unregister ŋNꂽꍇAFalse Ԃ܂B
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;
	// C EBhEꂽ̂ŁA\ƍXVs܂B
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();

	return TRUE;
}

int CCBeditApp::ExitInstance()
{
	//TODO: ǉ\[Xꍇɂ͂Ă
	AfxOleTerm(FALSE);

	return CWinAppEx::ExitInstance();
}

//I[o[Ch AddDocTemplate()
void CCBeditApp::AddDocTemplate(CDocTemplate* pTemplate) //ǉ
{
	if (m_pDocManager == NULL)
		m_pDocManager = new CMyDocManager;
	//NX CDocManager ύX
	m_pDocManager->AddDocTemplate(pTemplate);
}

//---------------------------------------------------------------------------
//		CMyDocManager NX̎
//---------------------------------------------------------------------------
//
IMPLEMENT_DYNAMIC( CMyDocManager, CDocManager )

//
//		DoPromptFileName I[o[Ch邽߂̃NX̒`
//
static void AppendFilterSuffix(CString& filter, OPENFILENAME& ofn,
	CDocTemplate* pTemplate, CString* pstrDefaultExt)
{
	ENSURE_VALID(pTemplate);
	ASSERT_KINDOF(CDocTemplate, pTemplate);

	CString strFilterExt, strFilterName;
	if (pTemplate->GetDocString(strFilterExt, CDocTemplate::filterExt) &&
		!strFilterExt.IsEmpty() &&
		pTemplate->GetDocString(strFilterName, CDocTemplate::filterName) &&
		!strFilterName.IsEmpty())
	{
		if (pstrDefaultExt != NULL)
			pstrDefaultExt->Empty();

		// add to filter
		filter += strFilterName;
		ASSERT(!filter.IsEmpty());  // must have a file type name
		filter += (TCHAR)'\0';  // next string please
	}

	int iStart = 0;
	do
	{
		CString strExtension = strFilterExt.Tokenize(_T(";"), iStart);

		if (iStart != -1)
		{
			// a file based document template - add to filter list

			// If you hit the following ASSERT, your document template 
			// string is formatted incorrectly.  The section of your 
			// document template string that specifies the allowable file
			// extensions should be formatted as follows:
			//    .<ext1>;.<ext2>;.<ext3>
			// Extensions may contain wildcards (e.g. '?', '*'), but must
			// begin with a '.' and be separated from one another by a ';'.
			// Example:
			//    .jpg;.jpeg
			ASSERT(strExtension[0] == '.');
			if ((pstrDefaultExt != NULL) && pstrDefaultExt->IsEmpty())
			{
				// set the default extension
				*pstrDefaultExt = strExtension.Mid(1);  // skip the '.'
				ofn.lpstrDefExt = const_cast< LPTSTR >((LPCTSTR)(*pstrDefaultExt));
				ofn.nFilterIndex = ofn.nMaxCustFilter + 1;  // 1 based number
			}

			filter += (TCHAR)'*';
			filter += strExtension;
			filter += (TCHAR)';';  // Always append a ';'.  The last ';' will get replaced with a '\0' later.
		}
	} while (iStart != -1);

	filter.SetAt(filter.GetLength() - 1, '\0');;  // Replace the last ';' with a '\0'
	ofn.nMaxCustFilter++;
}

BOOL CMyDocManager::DoPromptFileName(CString& fileName, UINT nIDSTitle, DWORD lFlags, BOOL bOpenFileDialog, CDocTemplate* pTemplate)
{
	CFileDialog dlgFile(bOpenFileDialog, NULL, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, NULL, NULL, 0);

	CString title;
	ENSURE(title.LoadString(nIDSTitle));

	dlgFile.m_ofn.Flags |= lFlags;

	CString strFilter;
	CString strDefault;
	if (pTemplate != NULL)
	{
		ASSERT_VALID(pTemplate);
		AppendFilterSuffix(strFilter, dlgFile.m_ofn, pTemplate, &strDefault);		// _Afx 폜
	}
	else
	{
		// do for all doc template
		POSITION pos = m_templateList.GetHeadPosition();
		BOOL bFirst = TRUE;
		while (pos != NULL)
		{
			pTemplate = (CDocTemplate*)m_templateList.GetNext(pos);
		AppendFilterSuffix(strFilter, dlgFile.m_ofn, pTemplate,
				bFirst ? &strDefault : NULL);	// _Afx 폜
			bFirst = FALSE;
		}
	}

	// append the "*.txt" text files filter		//  ǉ
	strFilter += _T("Text Files (*.txt)");
	strFilter += (TCHAR)'\0';   // next string please
	strFilter += _T("*.txt");
	strFilter += (TCHAR)'\0';   // last string
	dlgFile.m_ofn.nMaxCustFilter++;

	// append the "*.g1m" Casio Basic files filter		//  ǉ
	strFilter += _T("Casio Basic Files (*.g1m)");
	strFilter += (TCHAR)'\0';   // next string please
	strFilter += _T("*.g1m");
	strFilter += (TCHAR)'\0';   // last string
	dlgFile.m_ofn.nMaxCustFilter++;

	// append the "*.g3m" Casio Basic files filter		//  ǉ
	strFilter += _T("Casio Basic Files (*.g3m)");
	strFilter += (TCHAR)'\0';   // next string please
	strFilter += _T("*.g3m");
	strFilter += (TCHAR)'\0';   // last string
	dlgFile.m_ofn.nMaxCustFilter++;

	// append the "*.*" all files filter
	CString allFilter;
	VERIFY(allFilter.LoadString(AFX_IDS_ALLFILTER));
	strFilter += allFilter;
	strFilter += (TCHAR)'\0';   // next string please
	strFilter += _T("*.*");
	strFilter += (TCHAR)'\0';   // last string
	dlgFile.m_ofn.nMaxCustFilter++;

	dlgFile.m_ofn.lpstrFilter = strFilter;
	dlgFile.m_ofn.lpstrTitle = title;
	dlgFile.m_ofn.lpstrFile = fileName.GetBuffer(_MAX_PATH);

	INT_PTR nResult = dlgFile.DoModal();
	fileName.ReleaseBuffer();
	return nResult == IDOK;
}



// CCBeditApp bZ[W nh[


// AvP[Ṽo[WɎg CAboutDlg _CAO

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// _CAO f[^
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_ABOUTBOX };
#endif

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

// 
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(IDD_ABOUTBOX)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()

// _CAOs邽߂̃AvP[V R}h
void CCBeditApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

// CCBeditApp ̃JX^}CYꂽǂݍ݃\bhƕۑ\bh

void CCBeditApp::PreLoadState()
{
	BOOL bNameValid;
	CString strName;
	bNameValid = strName.LoadString(IDS_EDIT_MENU);
	ASSERT(bNameValid);
	GetContextMenuManager()->AddMenu(strName, IDR_POPUP_EDIT);
}

void CCBeditApp::LoadCustomState()
{
}

void CCBeditApp::SaveCustomState()
{
}

// CCBeditApp bZ[W nh[
